/*
 * @Author: gyq
 * @Date: 2022-02-18 12:27:55
 * @LastEditTime: 2022-03-17 11:14:35
 * @LastEditors: your name
 * @Description:
 * @FilePath: \assets\image.js
 */
$(function(){
    webveiwFuns.ready(function(){
        initImageOp();
    })
    var state = false;
    // 初始化图片操作
    function initImageOp(){
        console.log(RE);
        // 点击视频区域
        $("#editor").on('click', 'img:not(.eleImg,[smilieid])', function(){
            var $this = $(this);
            if(state){
                return;
            }
            // 设置图片容器
            setImageBox($this);
        });
        // 设置图片容器
        function setImageBox(dom){
            // 点击禁止编辑
            $("#editor").removeAttr('contenteditable');
            var $box = dom.parent('[data-node="imageOpBox"]');
            if(!$box.length){
                dom.wrap('<div class="img-op-box" data-node="imageOpBox" contenteditable="false"></div>');
                $box = dom.parent('[data-node="imageOpBox"]');
            }
            var $deleteBtn = $box.find('.delete');
            var $setSnapshotBtn = $box.find('.setsnapshot-box');
            if(!$deleteBtn.length){
                $box.append('<span class="delete"></span>');
                $deleteBtn = $box.find('.delete');
            }
            if(!dom.hasClass('hr-img') && !$setSnapshotBtn.length){
                var snapshot = dom.attr('snapshot');
                if(snapshot == 'true'){
                    $box.append('<div class="setsnapshot-box"><span class="setsnapshot">当前封面</span></div>');
                    dom.attr('snapshot', 'true');
                }else{
                    $box.append('<div class="setsnapshot-box"><span class="setsnapshot">设为帖子封面</span></div>');
                }
                $setSnapshotBtn = $box.find('.setsnapshot-box');
            }
            // 容器获取焦点
            $box.on('focus', function(){
                console.log('img box focus');
                $box.addClass('active');
                state = true;
            })
            // 容器失去焦点
            $box.on('blur',function(){
                console.log('img box blur');
                state = false;
                $("#editor").attr('contenteditable', 'true');
                var img = $box.find('img');
                $box.replaceWith(img);
            })
            // 设置为封面
            $box.on('click','.setsnapshot-box', function(){
                var snapshot = dom.attr('snapshot');
                if(snapshot == 'true'){
                    return;
                }
                console.log('设置封面');
                $("#editor").find('img').removeAttr('snapshot');
                $(this).find('.setsnapshot').html('当前封面');
                dom.attr('snapshot', 'true');
                RE.callback();
            })
            // 删除图片
            $box.on('click','.delete', function(){
                console.log('删除图片');
                state = false;
                $box.remove();
                // 允许编辑
                $("#editor").attr('contenteditable', 'true');
                RE.backuprange();
                RE.callback();
            })

            $box.attr('tabindex', '-1');
            $box.trigger('focus');
        }
    }
})
