/*
 * @Author: gyq
 * @Date: 2022-03-14 16:45:26
 * @LastEditTime: 2022-03-15 13:00:41
 * @LastEditors: your name
 * @Description: 
 * @FilePath: \assets\remove.js
 */
$("#editor").on('keydown', function(e){
    if(e.key.toLowerCase() != 'backspace' && e.keyCode != 8){ return }
    var selection = window.getSelection();
    var range = selection.getRangeAt(0);
    var node = range.startContainer;
    var _this = this
      //判断子集
    if(node.id != 'editor'){
        while(node){
            if(node.parentElement.id == 'editor'){
                break
            }else{
                node = node.parentElement
            }
        }
        _this.$$prevNode = node.previousElementSibling
    }
    var info = {
        node,
        range
    }
    //判断上一个元素是否为锚点元素
    if(_this.$$prevNode && _this.$$prevNode.getAttribute('data-node') == 'videoBox'){
        var state = false
        //判断节点回归根节点
        if(node.id == 'editor'){
            console.log(1)
            state = true
        }else if(range.endOffset === 0 && range.startOffset === 0){
            console.log(2)
            state = true
        }else if(node == _this.$$nextNode){
            console.log(3)
            state = true
        }else if(node.innerText){
            console.log(4)
            var text = node.innerText.replace(/\n/g,'')
            state = text === ''
        }else if(node instanceof Text && !node.length){
            console.log(5)
            state = true
        }
    
        if(state){
            e.preventDefault()
            $(_this.$$prevNode).find('.is_video').trigger('click')
            delete _this.$$prevNode
            delete _this.$$nextNode
            return
        }
    }
    console.log(info)
    //记录后一个兄弟
    _this.$$nextNode = node.nextElementSibling
    //判断上一个为图片,当删除图片是对上一个锚点做修正
    if(
        node.id == 'editor' && 
        _this.$$prevNode && 
        (
            _this.$$prevNode.tagName.toLowerCase() == 'img' ||
            _this.$$prevNode.tagName.toLowerCase() == 'video'
        )
    ){
        _this.$$prevNode = _this.$$prevNode.previousElementSibling
    }
    
})
//$("#editor").on('delete', function(e){
//    if(e.key.toLowerCase() != 'backspace' && e.keyCode != 8){ return }
//    var selection = window.getSelection();
//    var range = selection.getRangeAt(0);
//    var node = range.startContainer;
//    var _this = this
//      //判断子集
//    if(node.id != 'editor'){
//        while(node){
//            if(node.parentElement.id == 'editor'){
//                break
//            }else{
//                node = node.parentElement
//            }
//        }
//        _this.$$prevNode = node.previousElementSibling
//    }
//    var info = {
//        node,
//        range
//    }
//    //判断上一个元素是否为锚点元素
//    if(_this.$$prevNode && _this.$$prevNode.getAttribute('data-node') == 'videoBox'){
//        var state = false
//        //判断节点回归根节点
//        if(node.id == 'editor'){
//            console.log(1)
//            state = true
//        }else if(range.endOffset === 0 && range.startOffset === 0){
//            console.log(2)
//            state = true
//        }else if(node == _this.$$nextNode){
//            console.log(3)
//            state = true
//        }else if(node.innerText){
//            console.log(4)
//            var text = node.innerText.replace(/\n/g,'')
//            state = text === ''
//        }else if(node instanceof Text && !node.length){
//            console.log(5)
//            state = true
//        }
//
//        if(state){
//            e.preventDefault()
//            $(_this.$$prevNode).find('.is_video').trigger('click')
//            delete _this.$$prevNode
//            delete _this.$$nextNode
//            return
//        }
//    }
//    console.log(info)
//    //记录后一个兄弟
//    _this.$$nextNode = node.nextElementSibling
//    //判断上一个为图片,当删除图片是对上一个锚点做修正
//    if(
//        node.id == 'editor' &&
//        _this.$$prevNode &&
//        (
//            _this.$$prevNode.tagName.toLowerCase() == 'img' ||
//            _this.$$prevNode.tagName.toLowerCase() == 'video'
//        )
//    ){
//        _this.$$prevNode = _this.$$prevNode.previousElementSibling
//    }
//
//})